"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
Array.prototype.unionSplit = function (secondArr, comparator, zip = (t) => t, thisArg = this) {
    const checkedIndexesFromSecondArr = [];
    const leftSplit = [];
    const innerJoin = [];
    thisArg.forEach(t => {
        const index = secondArr.findIndex(u => comparator(t, u));
        if (index !== -1) {
            //Save index for later filtering
            checkedIndexesFromSecondArr.push(index);
            innerJoin.push(zip(t, secondArr[index]));
        }
        else {
            leftSplit.push(t);
        }
    });
    const rightSplit = secondArr.filter((_, i) => !checkedIndexesFromSecondArr.includes(i));
    return { leftSplit, innerJoin, rightSplit };
};
