"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
require("../sum");
const customErrors_1 = require("../utils/customErrors");
Array.prototype.average = function (func = x => x, round = null, thisArg = this) {
    if (thisArg.length <= 0)
        throw new customErrors_1.Exception_OutOfBounds();
    if (round !== null) {
        if (round < 0)
            throw new customErrors_1.Exception_OutOfBounds();
        const roundInTens = Math.pow(10, round);
        return Math.round((thisArg.sum(func, thisArg) / thisArg.length) * roundInTens) / roundInTens;
    }
    return thisArg.sum(func, thisArg) / thisArg.length;
};
