"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
Array.prototype.groupBy = function (callback, func, thisArg = this) {
    const groupArr = thisArg.reduce((acc, element) => {
        const key = callback(element);
        if (acc[key] !== undefined) {
            acc[key].push(element);
        }
        else {
            acc[key] = [element];
        }
        return acc;
    }, {});
    if (func) {
        Object.keys(groupArr).forEach(key => {
            groupArr[key] = func(groupArr[key]);
        });
    }
    return groupArr;
};
