"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
require("../sortByAttr");
Array.prototype.median = function (func = x => x, tieBreaker = -1, thisArg = this) {
    const sorted = thisArg.sortByAttr(func, "ASC", thisArg);
    const middle = (sorted.length - 1) / 2;
    if (Number.isInteger(middle))
        return sorted[middle];
    return sorted[tieBreaker < 0 ? Math.floor(middle) : Math.ceil(middle)];
};
